import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { FormGroup, NgForm, ValidatorFn } from '@angular/forms';
import { MatFormFieldAppearance } from '@angular/material/form-field';
import { SdLabelDefDirective, SdSuffixDefDirective, SdViewDefDirective } from '@sd-angular/core/forms/directives';
import { ISdFormConfiguration, SdCustomValidator, SdFormControl } from '@sd-angular/core/forms/models';
import { SdPatternType, SdSize } from '@sd-angular/core/utilities/models';
import * as i0 from "@angular/core";
export declare class SdInput implements OnDestroy, OnInit, AfterViewInit {
    #private;
    private ref;
    private formConfig;
    id: string;
    autoId?: string;
    set _autoId(val: string | undefined | null);
    set _name(val: string | undefined);
    appearance: MatFormFieldAppearance;
    size: SdSize;
    set _form(val: NgForm | FormGroup | undefined | null);
    label?: string;
    set _label(val: string | undefined);
    helperText?: string;
    set _helperText(val: string | undefined);
    placeholder?: string;
    set _placeholder(val: string | undefined);
    type: 'text' | 'number' | 'password' | 'email';
    hideInlineError: boolean;
    set _hideInlineError(val: boolean | '');
    set _blurOnEnter(val: boolean | '');
    set model(value: any);
    modelChange: EventEmitter<any>;
    required: boolean;
    set _required(val: boolean | '' | undefined | null);
    readonly: boolean;
    set _readonly(val: boolean | '');
    minlength?: number;
    set _minlength(val: number | undefined | null);
    maxlength?: number;
    set _maxlength(val: number | undefined | null);
    set _pattern(val: SdPatternType | string | undefined | null);
    patternErrorMessage?: string;
    set _patternErrorMessage(val: string | undefined | null);
    set _validator(value: SdCustomValidator | undefined);
    inlineError?: string;
    set _inlineError(val: string);
    set disabled(val: boolean | '' | undefined | null);
    viewed: boolean;
    set _viewed(val: boolean | '' | undefined | null);
    hyperlink?: string | null;
    tooltip?: string;
    sdChange: EventEmitter<any>;
    sdFocus: EventEmitter<any>;
    sdBlur: EventEmitter<any>;
    sdFocusForceBlur: EventEmitter<any>;
    keyupEnter: EventEmitter<any>;
    control?: ElementRef;
    sdSuffixDef?: SdSuffixDefDirective;
    sdLabelDef?: SdLabelDefDirective;
    sdViewDef?: SdViewDefDirective;
    formControl: SdFormControl;
    isFocused: boolean;
    constructor(ref: ChangeDetectorRef, formConfig: ISdFormConfiguration);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    reValidate: () => void;
    customInlineErrorValidator(): ValidatorFn;
    onKeyupEnter: () => void;
    onFocus: () => void;
    onBlur: () => void;
    onClick: () => void;
    blur: () => void;
    focus: () => void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SdInput, [null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SdInput, "sd-input", never, { "_autoId": { "alias": "autoId"; "required": false; }; "_name": { "alias": "name"; "required": false; }; "appearance": { "alias": "appearance"; "required": false; }; "size": { "alias": "size"; "required": false; }; "_form": { "alias": "form"; "required": false; }; "_label": { "alias": "label"; "required": false; }; "_helperText": { "alias": "helperText"; "required": false; }; "_placeholder": { "alias": "placeholder"; "required": false; }; "type": { "alias": "type"; "required": false; }; "_hideInlineError": { "alias": "hideInlineError"; "required": false; }; "_blurOnEnter": { "alias": "blurOnEnter"; "required": false; }; "model": { "alias": "model"; "required": false; }; "_required": { "alias": "required"; "required": false; }; "_readonly": { "alias": "readonly"; "required": false; }; "_minlength": { "alias": "minlength"; "required": false; }; "_maxlength": { "alias": "maxlength"; "required": false; }; "_pattern": { "alias": "pattern"; "required": false; }; "_patternErrorMessage": { "alias": "patternErrorMessage"; "required": false; }; "_validator": { "alias": "validator"; "required": false; }; "_inlineError": { "alias": "inlineError"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "_viewed": { "alias": "viewed"; "required": false; }; "hyperlink": { "alias": "hyperlink"; "required": false; }; "tooltip": { "alias": "tooltip"; "required": false; }; }, { "modelChange": "modelChange"; "sdChange": "sdChange"; "sdFocus": "sdFocus"; "sdBlur": "sdBlur"; "sdFocusForceBlur": "sdFocusForceBlur"; "keyupEnter": "keyupEnter"; }, ["sdSuffixDef", "sdLabelDef", "sdViewDef"], never, true, never>;
}
export declare function backendErrorValidator(backendErrorMessage: string): ValidatorFn;
